# 
# Synthesis run script generated by Vivado
# 

proc create_report { reportName command } {
  set status "."
  append status $reportName ".fail"
  if { [file exists $status] } {
    eval file delete [glob $status]
  }
  send_msg_id runtcl-4 info "Executing : $command"
  set retval [eval catch { $command } msg]
  if { $retval != 0 } {
    set fp [open $status w]
    close $fp
    send_msg_id runtcl-5 warning "$msg"
  }
}
create_project -in_memory -part xc7z007sclg225-2

set_param project.singleFileAddWarning.threshold 0
set_param project.compositeFile.enableAutoGeneration 0
set_param synth.vivado.isSynthRun true
set_property webtalk.parent_dir /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/synthesis/Vivado/xilinx_benchmark/xilinx_benchmark.cache/wt [current_project]
set_property parent.project_path /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/synthesis/Vivado/xilinx_benchmark/xilinx_benchmark.xpr [current_project]
set_property default_lib xil_defaultlib [current_project]
set_property target_language VHDL [current_project]
set_property ip_output_repo /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/synthesis/Vivado/xilinx_benchmark/xilinx_benchmark.cache/ip [current_project]
set_property ip_cache_permissions {read write} [current_project]
read_vhdl -library xil_defaultlib {
  /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/src/Libraries/CAN_FD_frame_format.vhd
  /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/src/Libraries/CAN_FD_register_map.vhd
  /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/src/Libraries/CANconstants.vhd
  /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/src/Libraries/CANcomponents.vhd
  /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/src/Registers_Memory_Interface/canfd_registers.vhd
  /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/src/Buffers_Message_Handling/rxBuffer.vhd
  /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/src/ID_transfer.vhd
  /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/src/Buffers_Message_Handling/txArbitrator.vhd
  /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/src/Buffers_Message_Handling/messageFilter.vhd
  /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/src/Interrupts/intManager.vhd
  /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/src/CAN_Core/operationControl.vhd
  /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/src/endian_swap.vhd
  /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/src/CAN_Core/protocolControl.vhd
  /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/src/CAN_Core/faultConf.vhd
  /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/src/CAN_Core/CRC.vhd
  /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/src/CAN_Core/bitStuffing_v2.vhd
  /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/src/CAN_Core/bitDeStuffing.vhd
  /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/src/CAN_Core/core_top.vhd
  /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/src/Bus_Timing_Synchronisation/prescaler_v3.vhd
  /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/src/Bus_Timing_Synchronisation/busSync.vhd
  /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/src/rst_sync.vhd
  /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/src/Event_Logger/logger.vhd
  /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/src/Buffers_Message_Handling/priorityDecoder.vhd
  /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/src/Buffers_Message_Handling/txtBuffer.vhd
  /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/src/CAN_top_level.vhd
}
# Mark all dcp files as not used in implementation to prevent them from being
# stitched into the results of this synthesis run. Any black boxes in the
# design are intentionally left as such for best results. Dcp files will be
# stitched into the design at a later time, either when this synthesis run is
# opened, or when it is stitched into a dependent implementation run.
foreach dcp [get_files -quiet -all -filter file_type=="Design\ Checkpoint"] {
  set_property used_in_implementation false $dcp
}
read_xdc /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/synthesis/Constraints/CTU_CAN_FD_Xilinx.sdc
set_property used_in_implementation false [get_files /DOKUMENTY/Skola/CVUT-FEL/CAN_FD_IP_Core/synthesis/Constraints/CTU_CAN_FD_Xilinx.sdc]


synth_design -top CAN_top_level -part xc7z007sclg225-2


# disable binary constraint mode for synth run checkpoints
set_param constraints.enableBinaryConstraints false
write_checkpoint -force -noxdef CAN_top_level.dcp
create_report "synth_1_synth_report_utilization_0" "report_utilization -file CAN_top_level_utilization_synth.rpt -pb CAN_top_level_utilization_synth.pb"
